%EX_02.m used for the second example given in section 8

clear, clc, T=1;
assign_po= [0.8+0.5i 0.8-0.5i];   assign_ze=[];       delay=1;                 
F=poly(assign_po);                B=poly(assign_ze);  B=[zeros(1,delay) B];   
thsim=poly2th(1,B,1,1,F); 
[zepo,k]=th2zp(thsim)
[ass_ze,ass_po]=getzp(zepo)

%-----Let input be white noise process
load input_sim;                        %--input_sim is white noise in column vector
input_sim=input_sim(1:20000,1);
output_sim = idsim(input_sim, thsim); 
z=[output_sim, input_sim];  
maxlength =4000;    
ze=dtrend(z(2000:1999+maxlength,:));   
zv=dtrend(z(10000:9999+maxlength,:));
vz=1; if size(ze)==size(zv), if norm(ze-zv)<eps, vz=0; end; end;

H=impz(B,F,200);
plot(H)
optimum_pole = new_M12_search(H,1)


%-------PLOT OF TRANSFER FUNCTION
optimum_pole = 0.8+0.5i;
optimum_NK   = 1;   

%---------------------- True system
w=(1:128)*pi/128/T;
gthsim=th2ff(thsim);               
[W, AMP, PHAS]= getff(gthsim);  %gthsim comes from the true system

%----------------------- FIR model 
NK=optimum_NK;
thfir=arx(ze,[0 10 NK]);  thfir=sett(thfir,T);
gthfir=th2ff(thfir,1,w);
[W,AMP_fir,PHAS_fir] = getff(gthfir); 

%------------------------ Orthonormal model
Npole=2;      %--Number of poles must be even number for KAUTZ
NA=1;    
NB=Npole-NA+1;
NK=optimum_NK-1;
nmax=max([NA, NB+NK+1]);  ii=nmax:maxlength;
NAflag=0;  if NA>1, NAflag=1; end;

pole=optimum_pole;
if abs(imag(pole)) > 0, Npole=Npole/2; end
poles=[];    poles(1:Npole)= pole;

PHI= [];  PHIV=[]; GAMMA=[]; 
[PHI,PHIV,GAMMA] = origin_ortho(poles,ze,ze,NAflag,w,T,NK); 
THETA=PHI(ii-NK,:)\ze(ii,1); 
GAMMAth_temp=GAMMA*THETA;
GAMMAth= GAMMAth_temp - (2*imag(GAMMAth_temp)*i);
AMP_ortho=abs(GAMMAth);
PHAS_ortho=phase(GAMMAth')'*180/pi;

%------- PLOT MAGNITUDE
figure(1), loglog(w,AMP,'rx'),
hold on, loglog(w,AMP_fir,'mo'),
hold on, loglog(w,AMP_ortho,'b');
if abs(imag(pole)) == 0
   xlabel('Normalized frequency');  %[w= (1:128)*pi/128/T]
   ylabel('Magnitude');
   title('True system(X-mark), FIR(Circle), LAGUERRE(Solid)'); 
else 
   xlabel('Normalized frequency');  %[w= (1:128)*pi/128/T]
   ylabel('Magnitude');
   title('True system(X-mark), FIR(Circle), KAUTZ(Solid)'); 
end 

%------- PLOT PHASE
figure(2),  semilogx(w,PHAS,'rx'),
hold on, semilogx(w,PHAS_fir,'mo'),
hold on, semilogx(w,PHAS_ortho,'b');
if abs(imag(pole)) == 0
   xlabel('Normalized frequency');  %[w= (1:128)*pi/128/T]
   ylabel('Phase');
   title('True system(X-mark), FIR(Circle), LAGUERRE(Solid)'); 
else
   xlabel('Normalized frequency');  %[w= (1:128)*pi/128/T]
   ylabel('Phase');
   title('True system(X-mark), FIR(Circle), KAUTZ(Solid)'); 
end

